# Class VulkanPipelineCacheCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineCacheCreateInfo

All Implemented Interfaces:
  `VulkanPipelineCacheCreateInfoType`

public final class VulkanPipelineCacheCreateInfo extends Object implements VulkanPipelineCacheCreateInfoType
The type of pipeline cache creation information.

See Also:
  - "VkPipelineCacheCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineCacheCreateInfo.Builder`
  Builds instances of type `VulkanPipelineCacheCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineCacheCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineCacheCreateInfo`.
  `static VulkanPipelineCacheCreateInfo`
  `copyOf(VulkanPipelineCacheCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineCacheCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineCacheCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineCacheCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `initialData`.
  `ByteBuffer`
  `initialData()`
  `static VulkanPipelineCacheCreateInfo`
  `of(Iterable<VulkanPipelineCacheCreateFlag> flags, ByteBuffer initialData)`
  Construct a new immutable `VulkanPipelineCacheCreateInfo` instance.
  `static VulkanPipelineCacheCreateInfo`
  `of(Set<VulkanPipelineCacheCreateFlag> flags, ByteBuffer initialData)`
  Construct a new immutable `VulkanPipelineCacheCreateInfo` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineCacheCreateInfo` with attribute values.
  `final VulkanPipelineCacheCreateInfo`
  `withFlags(VulkanPipelineCacheCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineCacheCreateInfo`
  `withFlags(Iterable<VulkanPipelineCacheCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineCacheCreateInfo`
  `withInitialData(ByteBuffer value)`
  Copy the current immutable object by setting a value for the `initialData` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineCacheCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineCacheCreateInfoType`
    Returns:
      The creation flags

  - ### initialData

    public ByteBuffer initialData()
    Specified by:
      `initialData` in interface `VulkanPipelineCacheCreateInfoType`
    Returns:
      A pointer to previously retrieved pipeline cache data. If the pipeline cache data is incompatible with the device, the pipeline cache will be initially empty.

  - ### withFlags

    public final VulkanPipelineCacheCreateInfo withFlags(VulkanPipelineCacheCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineCacheCreateInfo withFlags(Iterable<VulkanPipelineCacheCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withInitialData

    public final VulkanPipelineCacheCreateInfo withInitialData(ByteBuffer value)
    Copy the current immutable object by setting a value for the `initialData` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for initialData
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineCacheCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `initialData`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineCacheCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineCacheCreateInfo of(Set<VulkanPipelineCacheCreateFlag> flags, ByteBuffer initialData)
    Construct a new immutable `VulkanPipelineCacheCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `initialData` - The value for the `initialData` attribute
    Returns:
      An immutable VulkanPipelineCacheCreateInfo instance

  - ### of

    public static VulkanPipelineCacheCreateInfo of(Iterable<VulkanPipelineCacheCreateFlag> flags, ByteBuffer initialData)
    Construct a new immutable `VulkanPipelineCacheCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `initialData` - The value for the `initialData` attribute
    Returns:
      An immutable VulkanPipelineCacheCreateInfo instance

  - ### copyOf

    public static VulkanPipelineCacheCreateInfo copyOf(VulkanPipelineCacheCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineCacheCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineCacheCreateInfo instance

  - ### builder

    public static VulkanPipelineCacheCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineCacheCreateInfo`.

         VulkanPipelineCacheCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineCacheCreateFlag) // flags elements
            .setInitialData(java.nio.ByteBuffer) // required initialData
            .build();

    Returns:
      A new VulkanPipelineCacheCreateInfo builder